/* ############################################################################
   ###                                                                      ###
   ###                                                                      ###
   ###                @@@@@@@@  @@    @@  @@@@@@@@   @@@@@@                 ###
   ###                   @@     @@@@  @@  @@        @@    @@                ###
   ###                   @@     @@@@@@@@  @@@@@@    @@    @@                ###
   ###                   @@     @@  @@@@  @@        @@    @@                ###
   ###                @@@@@@@@  @@    @@  @@         @@@@@@                 ###
   ###                                                                      ###
   ###        Copyright (c) 1994,1995,1996,1997,1998,1999,2000,2001         ###
   ###     Version MsDos (c)       1994 -> 20/06/1998 - C++/Djgpp v 2.0     ###
   ###     Version Linux (c) 26/07/1998 -> 21/11/1998 - C++/GCC 2.x.x.x     ###
   ###                                                                      ###
   ###                   By FlashCode / Sebastien HELLEU                    ###
   ###                                                                      ###
   ###                   For any bug/comment, contact me:                   ###
   ###                      http://www.flashtux.org                         ###
   ###                      e-mail:flashcode@flashtux.org                   ###
   ###                                                                      ###
   ###                                                                      ###
   ############################################################################

==== This program is free software; you can redistribute it and/or modify
==== it under the terms of the GNU General Public License as published by
==== the Free Software Foundation; either version 2 of the License, or
==== (at your option) any later version.
====
==== This program is distributed in the hope that it will be useful,
==== but WITHOUT ANY WARRANTY; without even the implied warranty of
==== MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
==== GNU General Public License for more details.
====
==== You should have received a copy of the GNU General Public License
==== along with this program; if not, write to the Free Software
==== Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Auteur  : FlashCode <flashcode@flashtux.org>
Creation: 1994

26/08/2001: FlashCode:
    - ajout de la licence
    - reecriture du source
*/

static char id[] = "$Id: INFO (c) Copyright 2001/08/26 by FlashCode <flashcode@free.fr> $";

#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>

#ifdef MSDOS
    #include <conio.h>
#else
    #include <termios.h>
    #include <unistd.h>
#endif

unsigned int    annee, mois, jourm, jours,      /* date systeme */
                joura, heure, min, sec;
unsigned char   info_date, info_heure, fete,    /* parametres   */
                fete_lendemain, info_jours,     /* de ligne     */
                memos, sons, afficher_ecart,    /* de commande  */
                accents, couleur;
unsigned char   nom_fichier_memo[256];          /* nom du fichier des memos */
FILE            *fichier_memo;                  /* fichier des memos        */

unsigned char   nom_jour[7][9] =
                { "Dimanche", "Lundi", "Mardi", "Mercredi", "Jeudi",
                  "Vendredi", "Samedi" };

unsigned char   nom_mois[12][10] =
                { "Janvier","Fvrier","Mars","Avril","Mai","Juin","Juillet",
                  "Aot","Septembre","Octobre","Novembre","Dcembre" };

int             nombre_jours[12] = { 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

unsigned char   prenom[12][31][28] =
/*jan*/{{"!Marie - JOUR de l'AN","Basile","!Genevive","Odilon","Edouard",
       "Mlaine","Raymond","Lucien","!Alix","Guillaume","Paulin","!Tatiana",
       "!Yvette","!Nina","Rmi","Marcel","!Roseline","!Prisca","Marius",
       "Sbastien","!Agns","Vincent","Barnard","Franois de Sales",
       "-Conversion de St Paul","!Paule","!Angle","Thomas d'Aquin","Gildas",
       "!Martine","!Marcelle"},
/*fev*/ {"!Ella","-Prsentation","Blaise","!Vronique","!Agathe",
       "Gaston","!Eugnie","!Jacqueline","!Apolline","Arnaud",
       "-Notre-Dame de Lourdes","Flix","!Batrice","Valentin","Claude",
       "!Julienne","Alexis","!Bernadette","Gabin","!Aime","Pierre Damien",
       "!Isabelle","Lazare","Modeste","Romo","Nestor","!Honorine","Romain",
       "Auguste","",""},
/*mar*/ {"Aubin","Charles le Bon","Gunol","Casimir","Olive","Colette",
       "!Flicit","Jean de Dieu","!Franoise","Vivien","!Rosine",
       "!Justine","Rodrigue","!Mathilde","!Louise de Marillac","!Bndicte",
       "Patrice","Cyrille","Joseph","Herbert","!Clmence","!La","Victorien",
       "!Catherine de Sude","-Annonciation","!Larissa","Habib","Gontran",
       "!Gwladys","Amde","Benjamin"},
/*avr*/ {"Hugues","!Sandrine","Richard","Isodore","!Irne","Marcellin",
       "Jean-Baptiste de la Salle","!Julie","Gautier","Fulbert","Stanislas",
       "Jules","!Ida","Maxime","Paterne","Benot-Joseph Labre","Anicet",
       "Parfait","!Emma","!Odette","Anselme","Alexandre","Georges","Fidle",
       "Marc","!Alida","!Zita","!Valrie","!Catherine de Sienne","Robert",""},
/*mai*/ {"Jrmie - FETE du TRAVAIL","Boris","Philippe&Jacques","Sylvain",
       "!Judith", "!Prudence","!Gisle","Dsir - ANNIVERSAIRE 1945","Pacme",
       "!Solange","!Estelle","Achille","!Rolande","Mathias","!Denise","Honor",
       "Pascal","Eric","Yves","Bernardin","Constantin","Emile","Didier",
       "Donatien","!Sophie","Brenger","Augustin","Germain","Aymar",
       "Ferdinand","-Visitation"},
/*jun*/ {"Justin","!Blandine","Kvin","!Clotilde","Igor","Norbert","Gilbert",
       "Mdard","!Diane","Landry","Barnab","Guy","Antoine de Padoue",
       "Elise","!Germaine","Jean-Franois Rgis","Herv","Lonce","Romuald",
       "Silvre","Rodolphe","Alban","!Audrey","Jean-Baptiste","Salomon",
       "Anthelme","Fernand","Irne","Pierre&Paul","Martial",""},
/*jul*/ {"Thierry","Martinien","Thomas","Florent","Antoine","!Mariette",
       "Raoul","Thibaut","!Amandine","Ulrich","Benot","Olivier",
       "Henri&Jol","!Camille - FETE NATIONALE","Donald",
       "-N.D. du Mont Carmel","!Charlotte","Frdric","Arsne","!Marina","Victor",
       "!Marie-Madeleine","!Brigitte","!Christine","Jacques","Anne","!Nathalie",
       "Samson","!Marthe","!Juliette","Ignace de Loyola"},
/*aou*/ {"Alphonse","Julien","!Lydie","Jean-Marie Vianney","Abel",
       "-Transfiguration","Gatan","Dominique","Amour","Laurent","!Claire",
       "!Clarisse","Hippolyte","Evrard","!Marie - ASSOMPTION","Armel","Hyacinthe",
       "!Hlne","Jean Eudes","Bernard","Christophe","Fabrice",
       "!Rose de Lima","Barthlmy","Louis","!Natacha","!Monique","Augustin",
       "!Sabine","Fiacre","Aristide"},
/*sep*/ {"Gilles","!Ingrid","Grgoire","!Rosalie","!Rassa","Bertrand",
       "!Reine","-Nativit de Marie","Alain","!Ins","Adelphe","Apollinaire",
       "Aim","-La Ste Croix","Roland","!Edith","Renaud","!Nadge","!Emilie",
       "Davy","Matthieu","Maurice","!Thcle","!Thcle",/*"-Notre-Dame de la Merci",*/
       "Hermann","Cme&Damien","Vincent de Paul","Venceslas","Michel&Gabriel",
       "Jrme",""},
/*oct*/ {"!Thrse de l'Enfant Jsus","Lger","Grard","Franois d'Assise",
       "!Fleur","Bruno","Serge","!Plagie","Denis","Ghislain","Firmin",
       "Wilfried","Graud","Juste","!Thrse d'Avila","!Edwige",
       "Baudouin","Luc","Ren","!Adeline","!Cline","!Elodie",
       "Jean de Capistran","Florentin","Crpin","Dimitri","!Emeline",
       "Simon&Jude","Narcisse","!Bienvenue","Quentin"},
/*nov*/ {"Harold - TOUSSAINT","-Dfunts","Hubert","Charles","!Sylvie","!Bertille",
       "!Carine","Geoffroy","Thodore","Lon","Martin - ARMISTICE 1918",
       "Christian","Brice","Sidoine","Albert","!Marguerite","!Elisabeth","!Aude",
       "Tanguy","Edmond","-Prsentation de Marie","!Ccile","Clment",
       "!Flora","!Catherine","!Delphine","Sverin","Jacques de la Marche",
       "Saturnin","Andr",""},
/*dec*/ {"!Florence","!Viviane","Xavier","!Barbara","Grald","Nicolas",
       "Ambroise","-Immacule Conception","Pierre Fourier","Romaric",
       "Daniel","!Jeanne de Chantal","!Lucie","!Odile","!Ninon","!Alice",
       "Gal","Gatien","Urbain","Abraham","Pierre Canisius","!Franoise-Xavier",
       "Armand","!Adle","Emmanuel - NOEL","Etienne","Jean","-Sts Innocents",
       "David","Roger","Sylvestre"}};

#ifdef MSDOS
    #define BLACK           0
    #define BLUE            1
    #define GREEN           2
    #define CYAN            3
    #define RED             4
    #define MAGENTA         5
    #define BROWN           6
    #define LIGHTGRAY       7
    #define DARKGRAY        8
    #define LIGHTBLUE       9
    #define LIGHTGREEN      10
    #define LIGHTCYAN       11
    #define LIGHTRED        12
    #define LIGHTMAGENTA    13
    #define YELLOW          14
    #define WHITE           15
#else
    #define BLACK           0
    #define RED             1
    #define GREEN           2
    #define BROWN           3
    #define BLUE            4
    #define MAGENTA         5
    #define CYAN            6
    #define LIGHTGRAY       7
    #define DARKGRAY        8
    #define LIGHTRED        9
    #define LIGHTGREEN      10
    #define YELLOW          11
    #define LIGHTBLUE       12
    #define LIGHTMAGENTA    13
    #define LIGHTCYAN       14
    #define WHITE           15
#endif

#ifndef MSDOS
    struct termios  ot1, nt1;
#endif

short   x_curseur;

/* ========================================================================== */

/*
#ifdef MSDOS
    void __crt0_glob_function()
    {
    }

    void __crt0_load_environment_file()
    {
    }

    void __crt0_setup_arguments()
    {
    }
#endif
*/

#ifndef MSDOS
void init_ecran_ansi()
{
    tcgetattr(1, &ot1); tcgetattr(1, &nt1);
    nt1.c_lflag = 0;
    nt1.c_iflag = 0;
    nt1.c_oflag = 0;
    nt1.c_cc[VMIN] = 1;
    nt1.c_cc[VTIME] = 0;

    tcsetattr(1, TCSANOW, &nt1);
}

void deinit_ecran_ansi()
{
    tcsetattr(1, TCSANOW, &ot1);
}
#endif

void fin_prog(int code_retour)
{
    #ifndef MSDOS
        printf("\n");
    #endif
    exit(code_retour);
}

/*
 * supprime_accents: supprime tous les accents dans une chaine de caracteres
 */

void supprime_accents(char *chaine)
{
    int     i, longueur;

    longueur = strlen(chaine);
    for (i = 0; i < longueur; i++)
        switch (chaine[i])
        {
            case '':
            case '':
            case '':
            case '':
                chaine[i] = 'e';
                break;
            case '':
                chaine[i] = 'a';
                break;
            case '':
                chaine[i] = 'c';
                break;
            case '':
            case '':
                chaine[i] = 'i';
                break;
            case '':
                chaine[i] = 'o';
                break;
            case '':
                chaine[i] = 'u';
                break;
        }
}

void print(unsigned char *chaine, ...)
{
    unsigned char   buffer[81];
    va_list         argptr;

    va_start(argptr, chaine);
    vsprintf(buffer, chaine, argptr);
    va_end(argptr);
    if (!accents)
        supprime_accents(buffer);
    #ifdef MSDOS
        if (couleur)
            cprintf("%s", buffer);
        else
            printf("%s", buffer);
    #else
        if (couleur)
            write(1, buffer, strlen(buffer));
        else
            printf("%s", buffer);
    #endif
    x_curseur += strlen(buffer);
}

void setcolor(int coul, int fond)
{
    #ifdef MSDOS
        textcolor(coul);
        textbackground(fond);
    #else
        if (coul & 0x08)
            print("\x1b[1;3%d;4%dm", coul & 7, fond);
        else
            print("\x1b[0;3%d;4%dm", coul, fond);
    #endif
}

/* ========================================================================== */

void affiche_aide_generale()
{
    couleur = 0;
    print("\nINFO  (c) Copyright 1994-2001 par FlashCode (Sebastien Helleu)\n\n");
    print("  INFO [-i[h][f][s][j]] [-m[+][nomfich]] [-s] [@...] [=date] [-liste] [-a] [-c]\n\n");
    print("      -i   Affiche la date.\n");
    print("              h    Ajoute l'heure.\n");
    print("              f    Ajoute le/la saint(e) du jour.\n");
    print("              s    Ajoute le/la saint(e) du lendemain.\n");
    print("              j    Ajoute le nombre de jours couls et restant.\n");
    print("      -m   Lit le fichier mmo et affiche un message si un vnement approche.\n");
    #ifdef MSDOS
        print("              +    Affiche le nbre de jours restant jusqu' la date d'un mmo.\n");
    #else
        /* probleme avec le 'a' accent grave sous X-Windows... */
        print("              +    Affiche le nbre de jours restant jusqu'a la date d'un mmo.\n");
    #endif
    print("           nomfich  Nom du fichier mmo ('memo.txt' par dfaut).\n");
    print("      -s   Supprime le son pour les mmos et les erreurs.\n");
    print("    @...   Cherche tous les prnoms commenant par ces lettres.\n");
    print("           (ces lettres peuvent tre un prnom complet; diff MAJ/min ignore)\n");
    print("   =date   Affiche le/la saint(e) de ce jour ('?' remplace un chiffre). \n");
    print("  -liste   Affiche la liste de tous les prnoms et ftes de l'anne.\n");
    print("      -a   Supprime les accents dans les prnoms affichs\n");
    #ifdef MSDOS
        print("      -c   Dsactive l'affichage en couleur\n\n");
    #else
        print("      -c   Dsactive l'affichage en couleur par Ansi\n\n");
    #endif
    print("Tapez: INFO -?e pour avoir des exemples d'utilisation de ce programme.\n");
    print("       INFO -?m pour l'aide sur les mmos (INFO -?me pour les exemples).\n");
    print("       INFO -licence pour voir la licence du programme.");
    fin_prog(0);
}

void affiche_licence()
{
    couleur = 0;
    print("\nINFO  (c) Copyright 1994,1995,1996,1997,1998,1999,2000,2001\n");
    print("          by FlashCode (Sebastien Helleu)\n\n");
    print("This program is free software; you can redistribute it and/or modify\n");
    print("it under the terms of the GNU General Public License as published by\n");
    print("the Free Software Foundation; either version 2 of the License, or\n");
    print("(at your option) any later version.\n");
    print("\n");
    print("This program is distributed in the hope that it will be useful,\n");
    print("but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
    print("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
    print("GNU General Public License for more details.\n");
    print("\n");
    print("You should have received a copy of the GNU General Public License\n");
    print("along with this program; if not, write to the Free Software\n");
    print("Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n");
    fin_prog(0);
}

void affiche_exemples()
{
    couleur = 0;
    print("\nINFO  (c) Copyright 1994-2001 par FlashCode (Sebastien Helleu)\n\n");
    print("  ---- EXEMPLES D'UTILISATION DU PROGRAMME INFO ----\n\n");
    print("INFO -i     affiche la date et l'heure.\n");
    print("INFO -if    affiche la date, l'heure et le/la saint(e) du jour.\n");
    print("INFO -ifs   idem prcdent + le/la saint(e) du lendemain.\n");
    print("INFO -ij    affiche la date, l'heure et le nombre de jours couls et restant.\n");
    print("INFO -ifsj  affiche toutes les informations.\n");
    print("INFO -m     affiche les mmos dont la date est proche (s'il y en a).\n");
    print("INFO -m+    idem prcdent + nombre de jours restant jusqu' la date du mmo.\n\n");
    print("INFO -ifsj -m+   affiche toutes les infos et les mmos.\n\n");
    print("INFO @sebastien  affiche la date de la Saint Sbastien (c'est--dire le 20/01).\n");
    print("INFO @p          affiche tous les prnoms commenant par un P.\n\n");
    print("INFO =1.??    affiche les saint(e)s du premier jour de chaque mois.\n\n");
    print("  N.B.: Un '?' remplace 1 SEUL chiffre.\n");
    print("        Donc 'INFO =1.?' affiche les saint(e)s du premier jour de chaque mois de");
    print("          Janvier  Septembre.\n");
    fin_prog(0);
}

void affiche_aide_memos()
{
    couleur = 0;
    print("\nINFO  (c) Copyright 1994-2001 par FlashCode (Sebastien Helleu)\n\n");
    print("  ---- AIDE SUR LES MEMOS ET LA STRUCTURE DU FICHIER MEMO ----\n\n");
    print("Le fichier mmo doit respecter certaines rgles:\n");
    print(" - un seul vnement par ligne,\n");
    print(" - chaque ligne doit correspondre  l'une des 3 syntaxes suivantes:\n");
    print("        1)  *prnom xx$\n");
    print("        2)  -jj/mm vnement xx$\n");
    print("        3)  ;commentaire\n");
    print("     Paramtres facultatifs:\n");
    print("       xx  nombre de jours  partir duquel INFO vous avertit (de 0  90)\n");
    print("        $  affiche l'avertissement seulement xx jours avant et le jour mme\n");
    print("           (au lieu de l'afficher tous les jours jusqu' la date de l'vnement)\n\n");
    print(" INFO ne vous prviendra des vnements dcrits dans le fichier mmo que si\n");
    print("  vous utilisez le paramtre '-m' en ligne de commande.\n\n");
    print(" Par dfaut, INFO vous prvient 1 semaine avant chaque fte, 2 semaines avant\n");
    print("  chaque vnement et vous le/la rappelle chaque jour jusqu' sa date.\n\n");
    print(" Astuce: si le libell d'un nom d'vnement se termine par un nombre ou par\n");
    print("  un '$' prcd d'un espace, ajoutez un espace  la fin de la ligne.\n");
    fin_prog(0);
}

void affiche_exemples_memos()
{
    couleur = 0;
    print("\nINFO  (c) Copyright 1994-2001 par FlashCode (Sebastien Helleu)\n\n");
    print("  ---- EXEMPLES DE LIGNES DU FICHIER MEMO ----\n\n");
    print("Ŀ\n");
    print("       Fichier mmo                           Explications                  \n");
    print("Ĵ\n");
    print(" *sebastien                 Affiche un message pour la Saint Sbastien tous \n");
    print("                            les jours du 6 au 20 janvier inclus             \n");
    print(" *sebastien $               Affiche 2 messages pour la Saint Sbastien: les \n");
    print("                            6 et 20 janvier                                 \n");
    print(" -5/12 Anniversaire Toto 3  Affiche le message 'Anniversaire Toto' tous les \n");
    print("                            jours du 2 au 5 dcembre inclus                 \n");
    print(" *guillaume $               Affiche 2 messages pour la Saint Guillaume: le  \n");
    print("                            27 dcembre (2 semaines avant) et le 10 janvier \n");
    print(" *bertrand 2$               Affiche 2 messages pour la Saint Bertrand: les  \n");
    print("                            4 et 6 septembre                                \n");
    print(" -8/9 Rentre des classes 0 Affiche 'Rentre des classes' le 8 septembre    \n");
    print("                            uniquement                                      \n");
    print(" *toto                      INCORRECT car la Saint 'Toto' n'existe pas      \n");
    print("                            encore dans le calendrier                       \n");
    print("\n");
    fin_prog(0);
}

/* ========================================================================== */

/*
 * lit_date_et_heure: lit la date et l'heure du systeme
 *                    renvoie: - jour de semaine entre 0 et 6
 *                             - jour du mois entre 1 et 31
 *                             - mois entre 1 et 12
 *                             - annee sur 4 chiffres
 *                             - heures, minutes, secondes
 */

void lit_date_et_heure()
{
    time_t      secondes_ecoulees;
    struct tm   *date_du_jour;

    secondes_ecoulees = time(NULL);
    date_du_jour = (struct tm *)malloc(sizeof(struct tm));
    date_du_jour = localtime(&secondes_ecoulees);
    jourm = date_du_jour->tm_mday;
    jours = date_du_jour->tm_wday;
    joura = date_du_jour->tm_yday+1;
    mois = date_du_jour->tm_mon+1;
    annee = date_du_jour->tm_year;
    heure = date_du_jour->tm_hour;
    min = date_du_jour->tm_min;
    sec = date_du_jour->tm_sec;

    if (annee < 80)
        annee += 2000;
    else
        annee += 1900;
}

/*
 * extrait_prenom: extrait un prenom pour une date donee
 *                 no_prenom: 0 = s'il y a 2 prenoms, ils sont tous deux extraits
 *                            1 = seulement le premier
 *                            2 = seulement le deuxieme (s'il y en a un)
 */

void extrait_prenom(unsigned char no_mois, unsigned char no_jour,
                    unsigned char no_prenom, unsigned char *chaine)
{
    unsigned char   buffer[50], buffer2[50], *pos;

    strcpy(buffer, prenom[no_mois][no_jour]);
    pos = strchr(buffer, '&');
    if (pos != NULL)
    {
        strcpy(buffer2, pos+1);
        pos[0] = '\0';
    }
    else
        buffer2[0] = '\0';
    chaine[0] = '\0';
    if ( (strlen(buffer) == 0) || (no_jour > nombre_jours[no_mois]) )
        return;
    if (no_prenom != 2)
    {
        if (buffer[0] == '!')
        {
            strcpy(chaine, "Ste ");
            strcpy(&chaine[4], &buffer[1]);
        }
        else
        {
            if (buffer[0] == '-')
                strcpy(chaine, &buffer[1]);
            else
            {
                strcpy(chaine, "St ");
                strcpy(&chaine[3], buffer);
            }
        }
    }
    if ( (no_prenom != 1) && (strlen(buffer2) != 0) )
    {
        if (no_prenom == 0)
        {
            strcat(chaine, " et ");
            strcpy(&chaine[strlen(chaine)], buffer2);
        }
        else
        {
            if (buffer2[0] == '!')
            {
                strcpy(chaine, "Ste ");
                strcpy(&chaine[strlen(chaine)], &buffer2[1]);
            }
            else
            {
                if (buffer2[0] == '-')
                    strcpy(&chaine[strlen(chaine)], &buffer2[1]);
                else
                {
                    strcpy(&chaine[strlen(chaine)], "St ");
                    strcpy(&chaine[strlen(chaine)], buffer2);
                }
            }
        }
    }
}

/* ========================================================================== */

/*
 * extrait_prenom_seul: extrait un prenom (le 1er ou le 2eme) pour une date
 *                      no_prenom = 1 ou 2
 */

void extrait_prenom_seul(unsigned char no_mois, unsigned char no_jour,
                         unsigned char no_prenom, unsigned char *chaine)
{
    unsigned char   res[50], *pos;

    if (no_prenom == 2)
    {
        pos = strchr(prenom[no_mois][no_jour], '&');
        if (pos == NULL)
        {
            chaine[0] = '\0';
            return;
        }
        strcpy(res, pos+1);
    }
    else
        strcpy(res, prenom[no_mois][no_jour]);
    if ( (strlen(res) > 0) && (no_jour < nombre_jours[no_mois]) )
    {
        if ( (res[0] == '!') || (res[0] == '-') )
            strcpy(res, &res[1]);
    }
    strcpy(chaine, res);
}

char mon_toupper(char car)
{
    if ( (car >= 'a') && (car <= 'z') )
        car -= 'a'-'A';
    else
        switch (car)
        {
            case '':
            case '':
            case '':
            case '':
                car = 'E'; break;
            case '':
                car = 'C'; break;
            case '':
                car = 'U'; break;
            case '':
            case '':
                car = 'I'; break;
            case '':
                car = 'O'; break;
        }
    return car;
}

int mon_strcasecmp(unsigned char *chaine1, unsigned char *chaine2)
{
    int     i;
    char    car1, car2;

    i = 0;
    while ( (chaine1[i] != 0) && (chaine2[i] != 0) )
    {
        car1 = mon_toupper(chaine1[i]);
        car2 = mon_toupper(chaine2[i]);
        if (car1 > car2)
            return 1;
        else
            if (car1 < car2)
                return -1;
        i++;
    }
    if (chaine1[i] == chaine2[i])
        return 0;
    else
        if (chaine1[i] > chaine2[i])
            return 1;
        else
            return -1;
}

int mon_strncasecmp(unsigned char *chaine1, unsigned char *chaine2, int nb)
{
    int     i;
    char    car1, car2;

    for (i = 0; i < nb; i++)
    {
        car1 = mon_toupper(chaine1[i]);
        car2 = mon_toupper(chaine2[i]);
        if (car1 > car2)
            return 1;
        else
            if (car1 < car2)
                return -1;
    }
    return 0;
}

void cherche_prenoms(unsigned char *mot)
{
    unsigned char   i, j, k, chaine[50];
    unsigned short  nb_trouve, long_mot;

    if (mot[0] == '\0')
    {
        fprintf(stderr, "\nINFO: paramtre '@' incomplet.\n");
        fin_prog(1);
    }
    nb_trouve = 0;
    printf("\nRecherche des prnoms commenant par '%s'...\n", mot);
    long_mot = strlen(mot);
    for (i = 0; i < 12; i++)
        for (j = 0; j < 31; j++)
            for (k = 1; k <= 2; k++)
            {
                extrait_prenom_seul(i, j, k, chaine);
                if (mon_strncasecmp(mot, chaine, long_mot) == 0)
                {
                    nb_trouve++;
                    if (nb_trouve == 1)
                        printf("-------------------------------------------------------------------------------\n");
                    extrait_prenom(i, j, 0, chaine);
                    printf("%2u %-9s  %s\n", j+1, nom_mois[i], chaine);
                }
            }
    printf("-------------------------------------------------------------------------------\n");
    printf("%3u prnom", nb_trouve);
    if (nb_trouve > 1) printf("s");
    printf(" trouv");
    if (nb_trouve > 1) printf("s");
    printf(".\n");
    fin_prog(0);
}

/* ========================================================================== */

unsigned short  nb_trouve;          /* nombre de dates+prnoms trouvs    */
unsigned char   *pos_point;         /* utilis seulement dans recurs_date */
unsigned char   chaine_recurs[50];  /* utilis seulement dans recurs_date */

/*
 * mon_str2int: transforme une chaine en entier POSITIF (-1 = erreur)
 */

int mon_str2int(unsigned char *chaine)
{
    int     i, res, mult;

    mult = 1;
    res = 0;
    for (i = strlen(chaine)-1; i >= 0; i--)
    {
        if (!isdigit(chaine[i]))
            return -1;
        res += (int)(chaine[i]-'0')*mult;
        mult *= 10;
    }
    return res;
}

/*
 * recurs_date: appele par 'affiche_prenom_dates' (NE PAS APPELER DIRECTEMENT)
 */

void recurs_date(unsigned char *chaine)
{
    int     i, j;
    unsigned char   chaine2[10];

    if (strchr(chaine, '?') != NULL)
    {
        strcpy(chaine2, chaine);
        for (i = 0; i < strlen(chaine2); i++)
            if (chaine2[i] == '?')
            {
                if (chaine2[i+1] == '?')
                {
                    for (j = 1; j < 32; j++)
                    {
                        chaine2[i] = (j/10)+'0';
                        chaine2[i+1] = (j%10)+'0';
                        recurs_date(chaine2);
                    }
                    return;
                }
                else
                {
                    for (j = 0; j < 10; j++)
                    {
                        chaine2[i] = j+'0';
                        recurs_date(chaine2);
                    }
                    return;
                }
            }
    }
    else
    {
        pos_point = strchr(chaine, '.');
        pos_point[0] = 0;
        i = mon_str2int(chaine);
        j = mon_str2int(pos_point+1);
        pos_point[0] = '.';
        if ( (i >= 1) && (j >= 1) && (j <= 12) && (i <= nombre_jours[j-1]) )
        {
            nb_trouve++;
            if (nb_trouve == 1)
                printf("\n-------------------------------------------------------------------------------\n");
            extrait_prenom(j-1, i-1, 0, chaine_recurs);
            printf("%2u %-9s  %s\n", i, nom_mois[j-1], chaine_recurs);
        }
    }
}

void affiche_prenom_dates(unsigned char *chaine_date)
{
    if (strlen(chaine_date) > 5)
    {
        fprintf(stderr, "\nINFO: date invalide.\n");
        fin_prog(1);
    }
    nb_trouve = 0;
    printf("\nAffichage des dates correspondant au critre '%s'...", chaine_date);
    recurs_date(chaine_date);
    if (nb_trouve == 0)
        printf("\n");
    else
        printf("-------------------------------------------------------------------------------\n");
    printf("%3u date", nb_trouve);
    if (nb_trouve > 1) printf("s");
    printf("+prnom");
    if (nb_trouve > 1) printf("s");
    printf(" affich");
    if (nb_trouve > 1) printf("s");
    printf(".\n");
    fin_prog(0);
}

/* ========================================================================== */

void liste_prenoms()
{
    unsigned char   i, j, chaine[50];

    printf("Liste des prnoms et ftes de l'anne...\n");
    printf("-------------------------------------------------------------------------------\n");
    for (i = 0; i < 12; i++)
        for (j = 0; j < 31; j++)
            if (j < nombre_jours[i])
            {
                extrait_prenom(i, j, 0, chaine);
                printf("%2u %-9s  %s\n", j+1, nom_mois[i], chaine);
            }
    printf("-------------------------------------------------------------------------------\n");
    fin_prog(0);
}

/* ========================================================================== */

int date_valide(unsigned char *chaine_date)
{
    unsigned char   i;

    for (i = 0; i < strlen(chaine_date); i++)
        if ( (!isdigit(chaine_date[i])) && (chaine_date[i] != '?')
            && (chaine_date[i] != '.') )
            return 0;
    return (strchr(chaine_date, '.') != 0) && (strlen(chaine_date) <= 5);
}

void analyse_ligne_cmd(int argc, char *argv[])
{
    unsigned char   i, j, car, chaine[256], *pos;

    info_date = 0; info_heure = 0; fete = 0; fete_lendemain = 0;
    info_jours = 0;
    memos = 0; sons = 1; afficher_ecart = 0;
    accents = 1; couleur = 1;
    if ( (argc == 1) || (strcmp(argv[1], "-?") == 0) )
        affiche_aide_generale();
    for (i = 1; i < argc; i++)
    {
        if (strcmp(argv[i], "-?") == 0)
            affiche_aide_generale();
        if (strcasecmp(argv[i], "-licence") == 0)
            affiche_licence();
        if (argv[i][0] == '@')
            cherche_prenoms(argv[i]+1);
        if (argv[i][0] == '=')
        {
            if (date_valide(argv[i]+1))
                affiche_prenom_dates(argv[i]+1);
            else
            {
                fprintf(stderr, "\nINFO: date invalide.\n");
                fin_prog(1);
            }
        }
        if (strcasecmp(argv[i], "-?E") == 0)
            affiche_exemples();
        if (strcasecmp(argv[i], "-?M") == 0)
            affiche_aide_memos();
        if (strcasecmp(argv[i], "-?ME") == 0)
            affiche_exemples_memos();
        if (strcasecmp(argv[i], "-LISTE") == 0)
            liste_prenoms();
        if (strncasecmp(argv[i], "-I", 2) == 0)
        {
            info_date = 1;
            for (j = strlen(argv[i])-1; j > 1; j--)
            {
                car = toupper(argv[i][j]);
                switch (car)
                {
                    case 'H':
                        info_heure = 1;
                        break;
                    case 'F':
                        fete = 1;
                        break;
                    case 'S':
                        fete_lendemain = 1;
                        break;
                    case 'J':
                        info_jours = 1;
                        break;
                    default:
                        fprintf(stderr,
                            "\nINFO: lettre '%c' incompatible avec l'option '-i'.\n",
                            argv[i][j]);
                        fin_prog(1);
                }
            }
        }
        else
            if (strncasecmp(argv[i], "-M", 2) == 0)
            {
                memos = 1;
                if (strlen(argv[i]) > 2)
                {
                    if (argv[i][2] == '+')
                    {
                        afficher_ecart = 1;
                        if (strlen(argv[i]) > 3)
                            strcpy(nom_fichier_memo, &argv[i][3]);
                        else
                            strcpy(nom_fichier_memo, "memo.txt");
                    }
                }
                else
                    strcpy(nom_fichier_memo, "memo.txt");
                if ( (fichier_memo = fopen(nom_fichier_memo, "rb")) == NULL)
                {
                    strcpy(chaine, argv[0]);
                    #ifdef MSDOS
                        pos = strrchr(chaine, '\\');
                    #else
                        pos = strrchr(chaine, '/');
                    #endif
                    if (pos == NULL)
                    {
                        fprintf(stderr,
                            "\nINFO: fichier mmo '%s' introuvable.\n",
                            nom_fichier_memo);
                        fin_prog(1);
                    }
                    strcpy(pos+1, nom_fichier_memo);
                    if ( (fichier_memo = fopen(chaine, "rb")) == NULL)
                    {
                        fprintf(stderr,
                            "\nINFO: fichier mmo '%s' introuvable.\n",
                            chaine);
                        fin_prog(1);
                    }
                }
            }
            else
                if (strcasecmp(argv[i], "-S") == 0)
                    sons = 0;
                else
                    if (strcasecmp(argv[i], "-A") == 0)
                        accents = 0;
                    else
                        if (strcasecmp(argv[i], "-C") == 0)
                            couleur = 0;
                        else
                        {
                            fprintf(stderr,
                                "\nINFO: paramtre '%s' inconnu.\n", argv[i]);
                            fin_prog(1);
                        }
    }
}

/* ========================================================================== */

void affiche_infos()
{
    unsigned char   fete_du_jour[50], fete_de_demain[50];
    unsigned char   partie1[80];    /* jour + heure + nb_jours + fete du jour */
    unsigned char   partie2[80];    /* fete du lendemain                      */
    int             long_totale;    /* longueur partie1+longueur partie2      */

    #ifndef MSDOS
        if (couleur)
            init_ecran_ansi();
    #endif
    x_curseur = 1;

    if (annee%4 != 0) nombre_jours[1] = 28;
    if (couleur)
        setcolor(LIGHTCYAN, BLACK);
    print("\n\r");
    sprintf(partie1, "%s %u", nom_jour[jours], jourm);
    if (jourm == 1) sprintf(&partie1[strlen(partie1)], "er");
    sprintf(&partie1[strlen(partie1)], " %s %u", nom_mois[mois-1], annee);
    if (info_heure)
        sprintf(&partie1[strlen(partie1)], ", %u:%02u", heure, min);
    if (info_jours)
        sprintf(&partie1[strlen(partie1)], ", %u-%u",
            joura, (annee%4 == 0)?366-joura:365-joura);
    if (fete)
    {
        extrait_prenom(mois-1, jourm-1, 0, fete_du_jour);
        sprintf(&partie1[strlen(partie1)], ", %s", fete_du_jour);
    }
    print("%s", partie1);
    if (fete_lendemain)
    {
        if (couleur)
            setcolor(CYAN, BLACK);
        if ( (jourm == nombre_jours[mois-1]) || (strlen(prenom[mois-1][jourm]) == 0) )
        {
            jourm = 1;
            mois++;
            if (mois > 12) mois = 1;
        }
        else
            jourm++;
        extrait_prenom(mois-1, jourm-1, 0, fete_de_demain);
        sprintf(partie2, " (demain: %s)", fete_de_demain);
        long_totale = strlen(partie1)+strlen(partie2);
        if (long_totale >= 80)
            print("\n\r%s", &partie2[1]);
        else
            print("%s", partie2);
    }

    if (couleur)
        setcolor(LIGHTGRAY, BLACK);
    #ifdef MSDOS
        if (couleur)
            normvideo();
    #else
        if (couleur)
            deinit_ecran_ansi();
    #endif

    print("\n\r");
}

/* ========================================================================== */

/*
 * quantieme: renvoie le quantieme d'une date
 *            Ici: 1 <= q_jour <= 31
 *                 1 <= q_mois <= 12
 */

int quantieme(short q_jour, short q_mois, short q_annee)
{
    int             res;
    unsigned char   i;

    /* annees precedentes + 1 pour chaque annee bissextile */
    res = (q_annee-1901)*365+(q_annee-1901)/4;
    /* comptabilise chaque mois ecoule dans l'annee en cours */
    for (i = 1; i < q_mois; i++) res += nombre_jours[i-1];
    /* comptabilise le nombre de jours ecoules du mois en cours */
    res += q_jour;
    /* annee bissextile et date apres le 28 fevrier ? */
    if ( (q_mois > 2) && (q_annee%4 == 0) )
        res++;
    return res;
}

unsigned char   ligne_memo[256];    /* ligne lue du fichier memo                    */
unsigned short  numero_ligne;       /* numero de ligne en cours de traitement       */
unsigned char   libelle[256];       /* prenom ou nom d'evenement                    */
short           jours_avant;        /* previent un certain nb de jours avant        */
unsigned char   repeter;            /* =1 si avertiss. ts les jours jusqu'a la date */
short           memo_jour;          /* jour du memo                                 */
short           memo_mois;          /* mois du memo                                 */
short           memo_annee;         /* annee du memo                                */
short           ecart_jours;        /* nb de jours d'ecart entre aujourd'hui        */
                                    /* et la date du memo                           */
unsigned char   memo_affiche;       /* =1 si au moins 1 memo affiche ou erreur      */

/*
 * erreur_memo: erreur dans une ligne du fichier memo
 */

void erreur_memo(unsigned char *message)
{
    if (!memo_affiche) print("\n\r");
    memo_affiche = 1;
    if (couleur)
        setcolor(LIGHTRED, BLACK);
    print("INFO: MEMO/erreur ligne %u: %s.\n\r", numero_ligne, message);
    if (sons)
        print("\a");
    #ifdef MSDOS
    #else
        usleep(200000);
    #endif
}

/*
 * analyse_options_ligne_memo: renvoie 0 si OK, -1 si erreur
 */

int analyse_options_ligne_memo()
{
    unsigned short  i;
    unsigned char   options[256];

    jours_avant = (ligne_memo[0] == '*') ? 7 : 14;
    repeter = 1;
    i = strlen(ligne_memo)-1;
    while ( (ligne_memo[i] != ' ') && (i > 0) ) i--;
    if ( (i > 0) && (i != strlen(ligne_memo)-1) )
    {
        strcpy(options, &ligne_memo[i+1]);
        if (options[strlen(options)-1] == '$')
        {
            repeter = 0;
            options[strlen(options)-1] = 0;
        }
        if (options[0] != 0)
        {
            jours_avant = mon_str2int(options);
            if (jours_avant > 90)
            {
                erreur_memo("nombre de jours incorrect");
                return -1;
            }
            if (jours_avant == -1)
            {
                strcpy(libelle, &ligne_memo[1]);
                jours_avant = (ligne_memo[0] == '*') ? 7 : 14;
            }
            else
            {
                strcpy(libelle, &ligne_memo[1]);
                libelle[i-1] = 0;
            }
        }
        else
        {
            strcpy(libelle, &ligne_memo[1]);
            libelle[i-1] = 0;
        }
    }
    else
        strcpy(libelle, &ligne_memo[1]);
    return 0;
}

/*
 * cherche_prenom_memo: renvoie 0 si OK, -1 si erreur
 */

int cherche_prenom_memo()
{
    unsigned char   i, j, chaine[256], *pos;

    for (i = 0; i < 12; i++)
        for (j = 0; j < 31; j++)
            if (prenom[i][j][0] != 0)
            {
                strcpy(chaine, prenom[i][j]);
                if ( (chaine[0] == '!') || (chaine[0] == '-') )
                    strcpy(chaine, &chaine[1]);
                pos = strchr(chaine, '&');
                if (pos != NULL)
                    pos[0] = '\0';
                if (mon_strcasecmp(chaine, libelle) == 0)
                {
                    memo_mois = i+1;
                    memo_jour = j+1;
                    return 0;
                }
                /* recherche dans le deuxieme prenom */
                if (pos != NULL)
                {
                    pos++;
                    if (mon_strcasecmp(chaine, libelle) == 0)
                    {
                        memo_mois = i+1;
                        memo_jour = j+1;
                        return 0;
                    }
                }
            }
    sprintf(chaine, "'%s' n'est pas dans le calendrier", libelle);
    erreur_memo(chaine);
    return -1;
}

/*
 * extrait_date_ligne_memo: renvoie 0 si OK, -1 si erreur
 */

int extrait_date_ligne_memo()
{
    unsigned char   *pos_slash, *pos_espace;

    pos_slash = strchr(ligne_memo, '/');
    pos_espace = strchr(ligne_memo, ' ');
    if ( (pos_slash == NULL) || (pos_espace == NULL) || (pos_slash > pos_espace) )
    {
        erreur_memo("syntaxe incorrecte");
        return -1;
    }
    pos_slash[0] = 0;
    memo_jour = mon_str2int(&ligne_memo[1]);
    if ( (memo_jour < 1) || (memo_jour > 31) )
    {
        erreur_memo("jour incorrect");
        return -1;
    }
    pos_slash[0] = '/';
    pos_espace[0] = 0;
    memo_mois = mon_str2int(&pos_slash[1]);
    if ( (memo_mois < 1) || (memo_mois > 12) )
    {
        erreur_memo("mois incorrect");
        return -1;
    }
    return 0;
}

/*
 * afficher_memo_trouve: affiche un memo
 */

void afficher_memo_trouve(unsigned char syntaxe1)
{
    unsigned char   chaine[50];

    if (!memo_affiche) print("\n\r");
    memo_affiche = 1;
    if (couleur)
        setcolor(LIGHTGREEN, BLACK);
    print("Memo > %d %s", memo_jour, nom_mois[memo_mois-1]);
    if (afficher_ecart)
    {
        if (couleur)
            setcolor(YELLOW, BLACK);
        switch (ecart_jours)
        {
            case  0:print(" [aujourd'hui]"); break;
            case  1:print(" [demain]"); break;
            case  7:print(" [dans 1 semaine]"); break;
            case 14:print(" [dans 2 semaines]"); break;
            case 21:print(" [dans 3 semaines]"); break;
            default:print(" [dans %d jours]", ecart_jours); break;
        }
    }
    print(": ");
    if (sons)
        print("\a");
    if (couleur)
        setcolor(WHITE, BLACK);
    if (syntaxe1)
    {
        extrait_prenom(memo_mois-1, memo_jour-1, 0, chaine);
        print("%s\n\r", chaine);
    }
    else
        print("%s\n\r", libelle);
    #ifdef MSDOS
    #else
        usleep(200000);
    #endif
}

void affiche_memos()
{
    short   i;

    #ifndef MSDOS
        init_ecran_ansi();
    #endif

    nombre_jours[1] = 28;
    lit_date_et_heure();
    memo_affiche = 0;
    numero_ligne = 1;
    while (fgets(ligne_memo, 255, fichier_memo) != NULL)
    {
        i = strlen(ligne_memo)-1;
        while ( (i >= 0) && ( (ligne_memo[i] == 13) || (ligne_memo[i] == 10) ) )
            ligne_memo[i--] = 0;
        if (ligne_memo[0] != 0)
            if (ligne_memo[0] != ';')
            {
                switch (ligne_memo[0])
                {
                    case '*':
                        if (analyse_options_ligne_memo() == 0)
                            if (cherche_prenom_memo() == 0)
                            {
                                /* Calcul de l'anne pour le mmo en fonction */
                                /* de la date du jour                         */
                                if ( (memo_mois < mois) ||
                                    ( (memo_mois == mois) && (memo_jour < jourm) ) )
                                    memo_annee = annee+1;
                                else
                                    memo_annee = annee;
                                ecart_jours =
                                    quantieme(memo_jour, memo_mois, memo_annee)-
                                    quantieme(jourm, mois, annee);
                                if ( (ecart_jours == 0) ||
                                    (ecart_jours == jours_avant) ||
                                    ( (ecart_jours < jours_avant) && (repeter) ) )
                                    afficher_memo_trouve(1);
                            }
                        break;
                    case '-':
                        if (analyse_options_ligne_memo() == 0)
                        {
                            if (extrait_date_ligne_memo() == 0)
                            {
                                if ( (memo_mois < mois) ||
                                    ( (memo_mois == mois) && (memo_jour < jourm) ) )
                                    memo_annee = annee+1;
                                else
                                    memo_annee = annee;
                                if ( (memo_jour == 29) && (memo_mois == 2)
                                    && (memo_annee%4 != 0) )
                                    memo_annee += 4-(memo_annee%4);
                                if ( ( (memo_jour == 29) && (memo_mois == 2) )
                                    || (memo_jour <= nombre_jours[memo_mois-1]) )
                                {
                                    ecart_jours =
                                        quantieme(memo_jour, memo_mois, memo_annee)-
                                        quantieme(jourm, mois, annee);
                                    if ( (ecart_jours == 0) ||
                                        (ecart_jours == jours_avant) ||
                                        ( (ecart_jours < jours_avant) && (repeter) ) )
                                    {
                                        strcpy(libelle, strchr(libelle, ' ')+1);
                                        afficher_memo_trouve(0);
                                    }
                                }
                            }
                            else
                                erreur_memo("date incorrecte");
                        }
                        break;
                    default:
                        erreur_memo("syntaxe incorrecte");
                        break;
                }
        }
        numero_ligne++;
    }
    fclose(fichier_memo);

    if (couleur)
        setcolor(LIGHTGRAY, BLACK);
    #ifdef MSDOS
        normvideo();
    #else
        deinit_ecran_ansi();
    #endif

    print(" \r");

}

/*  ========================================================================= */

int main(int argc, char *argv[])
{
    lit_date_et_heure();
    analyse_ligne_cmd(argc, argv);
    if (info_date) affiche_infos();
    if (memos) affiche_memos();
    fin_prog(0);
    return 0;       /* jamais atteint - pour que GCC soit content ! */
}
